    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------
    028     * AbstractIntervalXYDataset.java
    029     * ------------------------------
    030     * (C) Copyright 2004-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited).
    033     * Contributor(s):   -;
    034     *
    035     * $Id: AbstractIntervalXYDataset.java,v 1.3.2.1 2005/10/25 21:36:51 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 05-May-2004 : Version 1 (DG);
    040     * 15-Jul-2004 : Switched getStartX() and getStartXValue() methods and
    041     *               others (DG);
    042     * 18-Aug-2004 : Moved from org.jfree.data --> org.jfree.data.xy (DG);
    043     *
    044     */
    045
    046    package org.jfree.data.xy;
    047
    048
    049    /**
    050     * An base class that you can use to create new implementations of the
    051     * {@link IntervalXYDataset} interface.
    052     */
    053    public abstract class AbstractIntervalXYDataset extends AbstractXYDataset
    054                                                    implements IntervalXYDataset {
    055
    056        /**
    057         * Returns the start x-value (as a double primitive) for an item within a
    058         * series.
    059         *
    060         * @param series  the series index (zero-based).
    061         * @param item  the item index (zero-based).
    062         *
    063         * @return The value.
    064         */
    065        public double getStartXValue(int series, int item) {
    066            double result = Double.NaN;
    067            Number x = getStartX(series, item);
    068            if (x != null) {
    069                result = x.doubleValue();
    070            }
    071            return result;
    072        }
    073
    074        /**
    075         * Returns the end x-value (as a double primitive) for an item within a
    076         * series.
    077         *
    078         * @param series  the series index (zero-based).
    079         * @param item  the item index (zero-based).
    080         *
    081         * @return The value.
    082         */
    083        public double getEndXValue(int series, int item) {
    084            double result = Double.NaN;
    085            Number x = getEndX(series, item);
    086            if (x != null) {
    087                result = x.doubleValue();
    088            }
    089            return result;
    090        }
    091
    092        /**
    093         * Returns the start y-value (as a double primitive) for an item within a
    094         * series.
    095         *
    096         * @param series  the series index (zero-based).
    097         * @param item  the item index (zero-based).
    098         *
    099         * @return The value.
    100         */
    101        public double getStartYValue(int series, int item) {
    102            double result = Double.NaN;
    103            Number y = getStartY(series, item);
    104            if (y != null) {
    105                result = y.doubleValue();
    106            }
    107            return result;
    108        }
    109
    110        /**
    111         * Returns the end y-value (as a double primitive) for an item within a
    112         * series.
    113         *
    114         * @param series  the series (zero-based index).
    115         * @param item  the item (zero-based index).
    116         *
    117         * @return The value.
    118         */
    119        public double getEndYValue(int series, int item) {
    120            double result = Double.NaN;
    121            Number y = getEndY(series, item);
    122            if (y != null) {
    123                result = y.doubleValue();
    124            }
    125            return result;
    126        }
    127
    128    }